
/*
 * L3G4200DW[
 * 
 * ړIFGY-50 L3G4200D IICeXgvO
 * 
 * 
 */
#include  <REG51.H>	
#include  <math.h>    //Keil library  
#include  <stdio.h>   //Keil library	
#include  <INTRINS.H>
#define   uchar unsigned char
#define   uint unsigned int	
#define   	DataPort P2	//LCD1602f[^|[g
sbit	  	SCL=P1^0;      //IICNbNs`
sbit 	  	SDA=P1^1;      //IICf[^s`
sbit		LCM_RS=P0^2;   	//LCD1602R}h|[g
sbit    	LCM_RW=P0^1;   	//LCD1602R}h|[g		
sbit    	LCM_EN=P0^0;   	//LCD1602R}h|[g

//********************

#define WHO_AM_I 0x0F
#define CTRL_REG1 0x20
#define CTRL_REG2 0x21
#define CTRL_REG3 0x22
#define CTRL_REG4 0x23
#define CTRL_REG5 0x24
#define REFERENCE 0x25
#define OUT_TEMP 0x26
#define STATUS_REG 0x27
#define OUT_X_L 0x28
#define OUT_X_H 0x29
#define OUT_Y_L 0x2A
#define OUT_Y_H 0x2B
#define OUT_Z_L 0x2C
#define OUT_Z_H 0x2D
#define FIFO_CTRL_REG 0x2E
#define FIFO_SRC_REG 0x2F
#define INT1_CFG 0x30
#define INT1_SRC 0x31
#define INT1_TSH_XH 0x32
#define INT1_TSH_XL 0x33
#define INT1_TSH_YH 0x34
#define INT1_TSH_YL 0x35
#define INT1_TSH_ZH 0x36
#define INT1_TSH_ZL 0x37
#define INT1_DURATION 0x38
//****************************


#define	SlaveAddress   0xD2	  //W[IICoX̃X[uAhX`AALT ADDRESSsɂC
                          

typedef unsigned char  BYTE;
typedef unsigned short WORD;

BYTE BUF[8];                         //Mf[^obt@
uchar ge,shi,bai,qian,wan;           //\ϐ
int  dis_data;                       //ϐ
  uchar devid;

void delay(unsigned int k);
void InitLcd();                        //lcd1602̏
void InitL3G4200D();             //L3G4200D̏

void WriteDataLCM(uchar dataW);
void WriteCommandLCM(uchar CMD,uchar Attribc);
void DisplayOneChar(uchar X,uchar Y,uchar DData);
void conversion(uint temp_data);

void  Single_WriteL3G4200D(uchar REG_Address,uchar REG_data);   //f[^VOŏ
uchar Single_ReadL3G4200D(uchar REG_Address);                   //WX^f[^VOœǂݍ
void  Multiple_ReadL3G4200D();                                  //WX^f[^pœǂݍ
//------------------------------------
void Delay5us();
void Delay5ms();
void L3G4200D_Start();
void L3G4200D_Stop();
void L3G4200D_SendACK(bit ack);
bit  L3G4200D_RecvACK();
void L3G4200D_SendByte(BYTE dat);
BYTE L3G4200D_RecvByte();
void L3G4200D_ReadPage();
void L3G4200D_WritePage();

void display_x();
void display_y();
void display_z();

//-----------------------------------

//*********************************************************
void conversion(uint temp_data)  
{  
    wan=temp_data/10000+0x30 ;
    temp_data=temp_data%10000;   //vZ
	qian=temp_data/1000+0x30 ;
    temp_data=temp_data%1000;    //vZ
    bai=temp_data/100+0x30   ;
    temp_data=temp_data%100;     //vZ
    shi=temp_data/10+0x30    ;
    temp_data=temp_data%10;      //vZ
    ge=temp_data+0x30; 	
}

/*******************************/
void delay(unsigned int k)	
{						
unsigned int i,j;				
for(i=0;i<k;i++)
{			
for(j=0;j<121;j++)			
{;}}						
}
/*******************************/
void WaitForEnable(void)	
{					
DataPort=0xff;		
LCM_RS=0;LCM_RW=1;_nop_();
LCM_EN=1;_nop_();_nop_();
while(DataPort&0x80);	
LCM_EN=0;				
}					
/*******************************/
void WriteCommandLCM(uchar CMD,uchar Attribc)
{					
if(Attribc)WaitForEnable();	
LCM_RS=0;LCM_RW=0;_nop_();
DataPort=CMD;_nop_();	
LCM_EN=1;_nop_();_nop_();LCM_EN=0;
}					
/*******************************/
void WriteDataLCM(uchar dataW)
{					
WaitForEnable();		
LCM_RS=1;LCM_RW=0;_nop_();
DataPort=dataW;_nop_();	
LCM_EN=1;_nop_();_nop_();LCM_EN=0;
}		
/***********************************/
void InitLcd()				
{			
WriteCommandLCM(0x38,1);	
WriteCommandLCM(0x08,1);	
WriteCommandLCM(0x01,1);	
WriteCommandLCM(0x06,1);	
WriteCommandLCM(0x0c,1);
}			
/***********************************/
void DisplayOneChar(uchar X,uchar Y,uchar DData)
{						
Y&=1;						
X&=15;						
if(Y)X|=0x40;					
X|=0x80;			
WriteCommandLCM(X,0);		
WriteDataLCM(DData);		
}						

/**************************************
5usfBC(STC90C52RC@12M)
ɂ̊֐𒲐KvłBɁANbNꍇCKv
PTMCUgꍇAfBC֐𒲐
**************************************/
void Delay5us()
{
    _nop_();_nop_();_nop_();_nop_();
    _nop_();_nop_();_nop_();_nop_();
	_nop_();_nop_();_nop_();_nop_();
	_nop_();_nop_();_nop_();_nop_();
    _nop_();_nop_();_nop_();_nop_();
	_nop_();_nop_();_nop_();_nop_();
}

/**************************************
5msfBC(STC90C52RC@12M)
ɂ̊֐𒲐KvłBɁANbNꍇCKv
PTMCUgꍇAfBC֐𒲐
**************************************/
void Delay5ms()
{
    WORD n = 560;

    while (n--);
}

/**************************************
JnM
**************************************/
void L3G4200D_Start()
{
    SDA = 1;                    //f[^ʂAbvɂ
    SCL = 1;                    //NbNʂAbvɂ
    Delay5us();                 //fBC
    SDA = 0;                    //GbW𐶐
    Delay5us();                 //fBC
    SCL = 0;                    //NbNʂ_Eɂ
}

/**************************************
~M
**************************************/
void L3G4200D_Stop()
{
    SDA = 0;                    //f[^ʂ_Eɂ
    SCL = 1;                    //NbNʂAbvɂ
    Delay5us();                 //fBC
    SDA = 1;                    //オGbW𐶐
    Delay5us();                 //fBC
}

/**************************************
M𔭑
̓p[^:ack (0:ACK 1:NAK)
**************************************/
void L3G4200D_SendACK(bit ack)
{
    SDA = ack;                  //M
    SCL = 1;                    //NbNʂAbvɂ
    Delay5us();                 //fBC
    SCL = 0;                    //NbNʂ_Eɂ
    Delay5us();                 //fBC
}

/**************************************
MM
**************************************/
bit L3G4200D_RecvACK()
{
    SCL = 1;                    //NbNʂAbvɂ
    Delay5us();                 //fBC
    CY = SDA;                   //Mǂݎ
    SCL = 0;                    //NbNʂ_Eɂ
    Delay5us();                 //fBC

    return CY;
}

/**************************************
IICoXɂPBytef[^𑗐M
**************************************/
void L3G4200D_SendByte(BYTE dat)
{
    BYTE i;

    for (i=0; i<8; i++)         //8rbgJE^
    {
        dat <<= 1;              //f[^̍ŏʂVtg
        SDA = CY;               //f[^Mݒ
        SCL = 1;                //NbNʂAbvɂ
        Delay5us();             //fBC
        SCL = 0;                //NbNʂ_Eɂ
        Delay5us();             //fBC
    }
    L3G4200D_RecvACK();
}

/**************************************
IICoXPBytef[^M
**************************************/
BYTE L3G4200D_RecvByte()
{
    BYTE i;
    BYTE dat = 0;

    SDA = 1;                    //f[^ǂݍނߓAbvɂLɂ
    for (i=0; i<8; i++)         //8rbgJE^
    {
        dat <<= 1;
        SCL = 1;                //NbNʂAbvɂ
        Delay5us();             //fBC
        dat |= SDA;             //f[^ǂݍ             
        SCL = 0;                //NbNʂ_Eɂ
        Delay5us();             //fBC
    }
    return dat;
}

//PByte*******************************************

void Single_WriteL3G4200D(uchar REG_Address,uchar REG_data)
{
    L3G4200D_Start();                  //JnM
    L3G4200D_SendByte(SlaveAddress);   //foCXAhX{CgM𔭑
    L3G4200D_SendByte(REG_Address);    //WX^AhX
    L3G4200D_SendByte(REG_data);       //WX^AhX
    L3G4200D_Stop();                   //~M𔭑
}

//PByteǂݍ*****************************************
uchar Single_ReadL3G4200D(uchar REG_Address)
{  uchar REG_data;
    L3G4200D_Start();                          //JnM
    L3G4200D_SendByte(SlaveAddress);           //foCXAhX{CgM𔭑
    L3G4200D_SendByte(REG_Address);            //LjbgAhX𔭑AO
    L3G4200D_Start();                          //JnM
    L3G4200D_SendByte(SlaveAddress+1);         //foCXAhX{[hM𔭑
    REG_data=L3G4200D_RecvByte();              //WX^f[^ǂݏo
	L3G4200D_SendACK(1);   
	L3G4200D_Stop();                           //~M
    return REG_data; 
}
//*************************************************
//
//pf[^ǂݏo
//
//**************************************************
void Multiple_readL3G4200D(void)
{   uchar i;
    L3G4200D_Start();                          //JnM
    L3G4200D_SendByte(SlaveAddress);           //foCXAhX{CgM𔭑
    L3G4200D_SendByte(0x28);                   //LjbgAhX𔭑	
    L3G4200D_Start();                          //JnM
    L3G4200D_SendByte(SlaveAddress+1);         //foCXAhX{[hM𔭑
	 for (i=0; i<6; i++)                       //UByteAhXf[^pœǂݍށABUFɕۑ
    {
        BUF[i] = L3G4200D_RecvByte()&0xFF;     //BUFɕۑ
        if (i == 5)
        {
           L3G4200D_SendACK(1);                //Ō̃f[^ɂNOACKԓ
        }
        else
        {
          L3G4200D_SendACK(0);                //ACKX|X
       }
   }
    L3G4200D_Stop();                          //~M
    Delay5ms();
}


//*****************************************************************

//L3G4200DA-Yɂf[^V[gQƂďC***************
void InitL3G4200D()
{
   Single_WriteL3G4200D(CTRL_REG1, 0x0f);   //
   Single_WriteL3G4200D(CTRL_REG2, 0x00);   //
   Single_WriteL3G4200D(CTRL_REG3, 0x08);   //
   Single_WriteL3G4200D(CTRL_REG4, 0x00);  //
   Single_WriteL3G4200D(CTRL_REG5, 0x00);
}
//***********************************************************************
//X\
void display_x()
{  // float temp;

    BUF[0]= Single_ReadL3G4200D(0x28);
    BUF[1]= Single_ReadL3G4200D(0x29);//lvZif[^V[gQƁj

    dis_data=(BUF[1]<<8)+BUF[0];   //f[^vZ


	if(dis_data<0){
	dis_data=-dis_data;
    DisplayOneChar(2,0,'-');       //vXA}CX\
	}
	else DisplayOneChar(2,0,' ');  //Xy[X\


    conversion(dis_data);          //Kṽf[^ϊ
	DisplayOneChar(0,0,'X');       //0sA0 X\
    DisplayOneChar(1,0,':'); 
    DisplayOneChar(3,0,qian); 
	DisplayOneChar(4,0,'.'); 
    DisplayOneChar(5,0,bai); 
    DisplayOneChar(6,0,shi); 
	DisplayOneChar(7,0,ge); 
}

//***********************************************************************
//Y\
void display_y()
{    // float temp;
   BUF[2]= Single_ReadL3G4200D(0x2a);
   BUF[3]= Single_ReadL3G4200D(0x2b); //lvZif[^V[gQƁj



    dis_data=(BUF[3]<<8)+BUF[2];   //f[^vZ 
	if(dis_data<0){
	dis_data=-dis_data;
    DisplayOneChar(2,1,'-');       //vXA}CX\
	}
	else DisplayOneChar(2,1,' ');  //Xy[X\


    conversion(dis_data);          //Kṽf[^ϊ
	DisplayOneChar(0,1,'Y');       //1sA0 Y\
    DisplayOneChar(1,1,':'); 
    DisplayOneChar(3,1,qian); 
	DisplayOneChar(4,1,'.'); 
    DisplayOneChar(5,1,bai); 
    DisplayOneChar(6,1,shi);  
	DisplayOneChar(7,1,ge);  
}

//***********************************************************************
//Z\
void display_z()
{      //float temp;
   BUF[4]= Single_ReadL3G4200D(0x2c);
   BUF[5]= Single_ReadL3G4200D(0x2d); //lvZif[^V[gQƁj

    dis_data=(BUF[5]<<8)+BUF[4];    //f[^vZ    
	if(dis_data<0){
	dis_data=-dis_data;
    DisplayOneChar(10,1,'-');       //vXA}CX\
	}
	else DisplayOneChar(10,1,' ');  //Xy[X\


    conversion(dis_data);          //Kṽf[^ϊ
	DisplayOneChar(10,0,'Z');      //0sA10 Z\
    DisplayOneChar(11,0,':'); 
    DisplayOneChar(11,1,qian); 
	DisplayOneChar(12,1,'.'); 
    DisplayOneChar(13,1,bai); 
    DisplayOneChar(14,1,shi); 
	DisplayOneChar(15,1,ge);  
}


//*********************************************************
//**************
//*********************************************************
void main()
{ 
  delay(500);	                   //dfBC
  InitLcd();                       //t
  InitL3G4200D();                  //L3G4200D
  devid=Single_ReadL3G4200D(0X26); //xǂݍ݁AxAhXF0x26
  while(1)                         //[v
  {   
    display_x();                   //---------X\
    display_y();                   //---------Y\
    display_z();                   //---------Z\
    delay(1000);                    //fBC            
  }
} 
